<?php
add_event_handler('loc_end_section_init', 'section_init_travelmap');

function section_init_travelmap()
{
	global $tokens, $page, $conf, $template;
	
	$make_homepage = (isset($conf['TravelMap']) ? $conf['TravelMap']['make_homepage'] : false);
	if ((!in_array('travelmap', $tokens) && !$make_homepage) || ($tokens[0]!='' && $tokens[0]!='lang' && !in_array('travelmap', $tokens) && $make_homepage))
	{
		return;
	}
	
	load_language('plugin.lang', dirname(__FILE__).'/../');
	
	include 'default_config.php';
	
	if(isset($conf['TravelMap']['google_maps_api_key']))
	{
		$google_maps_api_key = $conf['TravelMap']['google_maps_api_key'];
	}
	if(isset($conf['TravelMap']['route_color']))
	{
		$route_color = $conf['TravelMap']['route_color'];
	}
	if(isset($conf['TravelMap']['travelmap_title']) && $conf['TravelMap']['travelmap_title'] != '')
	{
		$travelmap_title = trigger_change('render_category_name', $conf['TravelMap']['travelmap_title']);
	}
	if(isset($conf['TravelMap']['categories_title']) && $conf['TravelMap']['categories_title'] != '')
	{
		$categories_title = trigger_change('render_category_name', $conf['TravelMap']['categories_title']);
	}
	if(isset($conf['TravelMap']['load_all_images']))
	{
		$load_all_images = $conf['TravelMap']['load_all_images'];
	}
	
	$page['section'] = 'travelmap';
	$page['section_title'] = get_travelmap_section_title($travelmap_title, $categories_title);
	$page['title'] = $travelmap_title;
	$page['body_id'] = 'travelmap';
	
	$dir = dirname(__FILE__).'/../template/travelmap.tpl';
	$template->set_filenames(array('travelmap' => realpath($dir),));
	
	$query = '
		SELECT ' . TRAVELMAP_TABLE . '.id AS id, category, latitude, longitude, name, permalink, comment, ' . TRAVELMAP_TABLE . '.id AS map_point_id
			FROM ' . TRAVELMAP_TABLE . ', ' . CATEGORIES_TABLE . '
			WHERE category = ' . CATEGORIES_TABLE . '.id
				AND latitude IS NOT NULL
				AND longitude IS NOT NULL
				AND ' . get_sql_condition_FandF(
					array(
						'forbidden_categories' => 'category',
						'visible_categories' => 'category',
					),
					'', true
					) . '
			ORDER BY date
		;';
	
	$map_points = query2array($query, null, null);
	$i = 0;
	
	$query = '
		SELECT ' . IMAGES_TABLE . '.id AS id, path, ' . TRAVELMAP_TABLE . '.category AS category, ' . TRAVELMAP_TABLE . '.id AS map_point_id
			FROM ' . IMAGES_TABLE . ', ' . IMAGE_CATEGORY_TABLE . ', ' . TRAVELMAP_TABLE . '
			WHERE category_id = ' . TRAVELMAP_TABLE . '.category AND image_id = ' . IMAGES_TABLE . '.id
				AND ' . get_sql_condition_FandF(
					array(
						'forbidden_categories' => 'category',
						'visible_categories' => 'category',
						'forbidden_images' => 'image_id',
						'visible_images' => 'image_id',
					),
					'', true
					) . '
			ORDER BY date
		;';
	
	$map_photos = query2array($query, null, null);
	
	foreach($map_points as &$map_point)
	{
		if($i!=0)
		{
			$map_point['prec'] = $map_points[$i-1];
		}
		$map_point['name'] = trigger_change('render_category_name', $map_point['name']);
		$map_point['comment'] = trigger_change('render_category_description', $map_point['comment']) . '<div class="mapPhotos">';
		
		ob_start();
		foreach($map_photos as $map_photo)
		{
			if($map_photo['map_point_id'] == $map_point['map_point_id'])
			{
				$src_image = new SrcImage($map_photo);
				$derivative = new DerivativeImage('2small', $src_image);
				
				$image_url = $derivative->get_path();
				$generation_url = 'i.php?' . substr($image_url, 9);
				
				$map_point['comment'] .= '<br/><a href="' . make_picture_url(array('image_id' => $map_photo['id'], 'category' => array('id' => $map_point['category'], 'name' => $map_point['name'], 'permalink' => $map_point['permalink']))) . '"><!-- '.$map_point['category'].' --><img ' . ($load_all_images ? '' : '_') . 'src="' . $image_url . '" /><img ' . ($load_all_images ? '' : '_') . 'src="' . $generation_url . '" style="display: none;" /></a><br/>';
		
			}
		}
		ob_end_clean();
		
		$map_point['comment'] .= '</div>';
		
		$i++;
		unset($map_point);
	}
	
	$template->assign(
		array(
			'map_points' => $map_points,
			'rightPanelWidth' => 300,
			'google_maps_api_key' => $google_maps_api_key,
			'route_color' => $route_color
		)
	);
	
	$template->assign_var_from_handle('CONTENT', 'travelmap');
}
?>